#!/usr/local/bin/perl 
#
#               -------------
#	            Links
#               -------------
#               Links Manager
#
#         File: admin_html.pl
#  Description: This library contains all the html used in the admin 
#               interface.
#       Author: Alex Krohn
#        Email: alex@gossamer-threads.com
#          Web: http://www.gossamer-threads.com/
#       :
#     Ƨ@:konica  Hc :tengcy@pcmail.com.tw
#      Version: 4.0a
#
# COPYRIGHT NOTICE:
#
# Copyright 1999 Gossamer Threads Inc.  All Rights Reserved.
#
# This program is being distributed as shareware.  It may be used and
# modified free of charge for personal, academic, government or non-profit
# use, so long as this copyright notice and the header above remain intact.
# Any commercial use should be registered.  Please also send me an email,
# and let me know where you are using this script. By using this program 
# you agree to indemnify Gossamer Threads Inc. from any liability.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  Obtain written permission before redistributing this
# program over the Internet or in any other medium.  In all cases
# copyright and header must remain intact.
#
# Please check the README file for full details on registration.
# =====================================================================

##########################################################
##					  Globals							##
##########################################################

$body = qq|BODY BGCOLOR="#FFFFFF"|;

$html_search_options =  qq!
    <STRONG>jﶵ: (ϥ "*" j)</STRONG><BR>
    <INPUT TYPE="TEXT" NAME="keyword" SIZE=15 MAXSIZE=255> j <INPUT TYPE="TEXT" NAME="mh" VALUE="$db_max_hits" SIZE=3 MAXSIZE=4> wkӪƦr<BR>
    <INPUT TYPE="CHECKBOX" NAME="ma"> 󪺤ǰt <INPUT TYPE="CHECKBOX" NAME="cs"> Ϥjpg <INPUT TYPE="CHECKBOX" NAME="ww"> rǰt <INPUT TYPE="CHECKBOX" NAME="re"> WhF
!;
         
$html_footer = qq!
        <h4 align=center>&copy 1998 <a href="http://www.gossamer-threads.com/" target="_blank">Gossamer Threads Inc.</a></h4>
        <h4 align=center>ק <a href="http://jonas12.hypermart.net/cgi-bin/links/" target="_blank">cgi{p{.</a></h4>
!; 

##########################################################
##					  Adding					      ##
##########################################################

sub html_add_form {
# --------------------------------------------------------
# The add form page where the user fills out all the details
# on the new record he would like to add. You should use 
# &html_record_form to print out the form as it makes
# updating much easier. Feel free to edit &get_defaults
# to change the default values.

    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>sW</TITLE>
</HEAD>

<$body>
    <H2><TT>sW</TT></H2>
        <FORM ACTION="$db_script_url" METHOD="POST">
            |; &html_record_form (&get_defaults); print qq|
           <P><INPUT TYPE="HIDDEN" NAME="add_record" VALUE="1">
           <INPUT TYPE="SUBMIT" VALUE="n "> <INPUT TYPE="RESET" VALUE="M ">
         </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

sub html_add_success {
# --------------------------------------------------------
# The page that is returned upon a successful addition to
# the database. You should use &get_record and &html_record
# to verify that the record was inserted properly and to make
# updating easier.

    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>Ƥwn</TITLE>
</HEAD>

<$body>
    <H2><TT>Ƥwn</TT></H2>
    <P><Font face="sө,з" Size=2>UCUƤwn:</FONT>
       |; &html_record(&get_record($in{$db_key})); print qq|   
    <P><Font face="sө,з" Size=2>W[B~?</FONT>
    <FORM ACTION="$db_script_url" METHOD="POST">
       |; &html_record_form (&get_defaults); print qq|
    <P><INPUT TYPE="HIDDEN" NAME="add_record" VALUE="1">
    <INPUT TYPE="SUBMIT" VALUE="n "> <INPUT TYPE="RESET" VALUE="M ">
    </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

sub html_add_failure {
# --------------------------------------------------------
# The page that is returned if the addition failed. An error message 
# is passed in explaining what happened in $message and the form is
# reprinted out saving the input (by passing in %in to html_record_form).

    my ($message) = $_[0];
    
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE> ~! LkW[.</TITLE>
</HEAD>

<$body>
    <H2><TT><FONT COLOR="red"> ~! LkW[.</FONT></TT></H2>
    <P>HUOܦUnƦ: <FONT COLOR="red"><B>$message</B></FONT>
    <BR>Эץ󪺰Dιխsn.
    <P>
    <FORM ACTION="$db_script_url" METHOD="POST">
        |; &html_record_form (%in); print qq|
       <P><INPUT TYPE="HIDDEN" NAME="add_record" VALUE="1">
       <INPUT TYPE="SUBMIT" VALUE="n "> <INPUT TYPE="RESET" VALUE="M ">
     </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

sub html_add_record_mult {
# --------------------------------------------------------
# This page is returned upon successful completion of check_links.
# It really ownly works with multiple category additions, but should
# be generalized to work with other databases.

	my ($categories) = @_;

    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>ؿw[J.</TITLE>
</HEAD>

<$body>
    <H2><TT>ؿw[J.</TT></H2>
    <P><Font face="sө,з" Size=2>UCUؿw[J:
	<strong>$categories</strong>
	</FONT>
	
    $html_footer
</BODY>
</HTML>
|;
}

##########################################################
##					  Viewing					     ##
##########################################################

sub html_view_search {
# --------------------------------------------------------
# This page is displayed when a user requests to search the 
# database for viewing. 

    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>jƮw.</TITLE>
</HEAD>

<$body>
    <H2><TT>jƮw</TT></H2>
    <P>
    <FORM ACTION="$db_script_url" METHOD="GET">
    |;  &html_record_form(); print qq|
        <P>$html_search_options
        <P><INPUT TYPE="HIDDEN" NAME="view_records" VALUE="1">
        <INPUT TYPE="SUBMIT" VALUE="j"> <INPUT TYPE="RESET" VALUE="M ">
    </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

sub html_view_success {
# --------------------------------------------------------
# This page displays the results of a successful search. The hits
# are stored in an array @hits and the number of hits is calculated
# and stored in $numhits.
# A little work must be done to convert each hit to a hash to pass off
# to html_record for printing.

    my ($i, $col, %tmp);
    my (@hits) = @_;
    my ($numhits) = ($#hits+1) / ($#db_cols+1);
    my ($maxhits) = $db_max_hits;
    $maxhits = $in{'mh'} if ($in{'mh'});
    
    &html_print_headers;    
    print qq|
<HTML>
<HEAD>
    <TITLE>jG.</TITLE>
</HEAD>

<$body>
    <H2><TT>jG.</TT></H2>
|;
    if ($numhits == $maxhits) {
        print qq|<P>Ajwkӳ̤j <strong>$maxhits</strong> .
		 <A HREF="$db_search_next_url">U@ $maxhits</a>?
				|;
    }
    else {
        print qq|<P>Ajwk <strong>$numhits</strong> :
				 <P>|;
    }

# Go through each hit and convert the array to hash and send to 
# html_record for printing.
    for ($i = 0; $i < $numhits; $i++) {
        %tmp = &array_to_hash ($i, @hits); 
        print "<P>";
        &html_record (%tmp);
    }

print qq|
        <P><CENTER><A HREF="$db_script_url?view_search=1">sj?</A></CENTER>
    $html_footer
</BODY>
</HTML>
|;
}

sub html_view_failure {
# --------------------------------------------------------
# The search for viewing failed. The reason is stored in $message
# and a new search form is printed out.

    my ($message) = $_[0];
    
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>jw.</TITLE>
</HEAD>

<$body>
    <H2><TT><FONT COLOR="red">jw.</FONT></TT></H2>
    <P>HUOܦUjD. z: <FONT COLOR="red"><B>$message</B></FONT>
    <BR>Эץ󪺰Dιխsj.
    <P>
    <FORM ACTION="$db_script_url" METHOD="GET">
        |; &html_record_form(); print qq|
        <P>$html_search_options
        <P><INPUT TYPE="HIDDEN" NAME="view_records" VALUE="1">
        <INPUT TYPE="SUBMIT" VALUE="j"> <INPUT TYPE="RESET" VALUE="M ">
    </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

##########################################################
##					  Deleting					    ##
##########################################################

sub html_delete_search {
# --------------------------------------------------------
# The page is displayed when a user wants to delete records. First
# the user has to search the database to pick which records to delete.
# That's handled by this form.

    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>jƮwR</TITLE>
</HEAD>

<$body>
    <H2><TT>jƮwR</TT></H2>
    <P>jƮwAQRwsbƩΪ 
       <A HREF="$db_script_url?delete_form=1&$db_key=*"></a>:
    <P>
    <FORM ACTION="$db_script_url" METHOD="GET">
    |;  &html_record_form(); print qq|
        <P>$html_search_options
        <P><INPUT TYPE="HIDDEN" NAME="delete_form" VALUE="1">
        <INPUT TYPE="SUBMIT" VALUE="j"> <INPUT TYPE="RESET" VALUE="M ">
    </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

sub html_delete_form {
# --------------------------------------------------------
# The user has searched the database for deletion and must now
# pick which records to delete from the records returned. This page
# should produce a checkbox with name=ID value=delete for each record.
# We have to do a little work to convert the array @hits that contains
# the search results to a hash for printing.

    my ($status, @hits) = &query(); 
    my ($numhits) = ($#hits+1) / ($#db_cols+1);
    my ($maxhits) = $db_max_hits;
    $maxhits = $in{'mh'} if ($in{'mh'});
    
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>R</TITLE>
</HEAD>

<$body>
    <H2><TT>R</TT></H2>
    <P>ˬdUCƨǬOAƱR, Ы "R":
|;

    if ($numhits == $maxhits) {
        print qq|<P>Ajwkӳ̤j <strong>$maxhits</strong> .
				 <A HREF="$db_search_next_url">Next $maxhits</a>?
				|;
    }
    else {
        print qq|<P>Ajwk <strong>$numhits</strong> :
				 <P>|;
    }
    
print qq|<FORM ACTION="$db_script_url" METHOD="POST">
         <TABLE BORDER=1>|;

# Go through each hit and convert the array to hash and send to 
# html_record for printing. Also add a checkbox with name=key and value=delete.

    if ($status ne "ok") {  # There was an error searching!
        print qq|<TR><TD><FONT COLOR="RED" SIZE=4> ~: $status</FONT></TD></TR>|;
    }
    else {
# Print Column Headers
		print "<tr><th>$db_key</th>";	
		foreach $col (@db_record_header_columns) {
			print qq|<th>$col</th>|;
		}
		print "</tr>";

# Print Main Body.		
        for ($i = 0; $i < $numhits; $i++) {
            %tmp = &array_to_hash ($i, @hits);
            print qq|<TR><TD><INPUT TYPE=CHECKBOX NAME="$tmp{$db_key}" VALUE="delete"> $tmp{$db_key}</TD>|;
            &html_record_spreadsheet (%tmp);
            print qq|</TR>|;
        }
    }
print qq|
    </TABLE>
    <P><INPUT TYPE="HIDDEN" NAME="delete_records" VALUE="1">
       <INPUT TYPE="SUBMIT" VALUE="R"> <INPUT TYPE="RESET" VALUE="M ">
    </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

sub html_delete_success {
# --------------------------------------------------------
# This page let's the user know that the records were successfully
# deleted.

    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>ƧR</TITLE>
</HEAD>

<$body>
    <H2><TT>ƧR</TT></H2>
    <P>nDRƤw.
    $html_footer
</BODY>
</HTML>
|;
}

sub html_delete_failure {
# --------------------------------------------------------
# This page let's the user know that some/all of the records were
# not deleted (because they were not found in the database). 
# $errstr contains a list of records not deleted.

    my ($errstr) = $_[0];
    
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE> ~: LkR</TITLE>
</HEAD>

<$body>
    <H2><TT><FONT COLOR="red"> ~: LkR.</FONT></TT></H2>
    <P>UCUƤbƮw: <FONT COLOR="red">$errstr</FONT>.
    $html_footer
</BODY>
</HTML>
|;  
}

##########################################################
##					  Modifying							##
##########################################################
sub html_modify_search {
# --------------------------------------------------------
# The page is displayed when a user wants to modify a record. First
# the user has to search the database to pick which record to modify.
# That's handled by this form.

    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>jƮwק</TITLE>
</HEAD>

<$body>
    <H2><TT>jƮwק</TT></H2>
    <P>jƮwAQקwsbƩΪ
      <A HREF="$db_script_url?modify_form_mult=1&$db_key=*"></a>:
    <P>
    <FORM ACTION="$db_script_url" METHOD="GET">
    |;  &html_record_form(); print qq|
        <P>$html_search_options
        <P><INPUT TYPE="HIDDEN" NAME="modify_form_mult" VALUE="1">
        <INPUT TYPE="SUBMIT" VALUE="j "> <INPUT TYPE="RESET" VALUE="M ">
    </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

sub html_modify_form {
# --------------------------------------------------------
# The user has searched the database for modification and must now
# pick which record to modify from the records returned. This page
# should produce a radio button with name=modify value=ID for each record.
# We have to do a little work to convert the array @hits that contains
# the search results to a hash for printing.

    my ($status, @hits) = &query(); 
    my ($numhits) = ($#hits+1) / ($#db_cols+1);
    if ($numhits == 1) {            # Only one result, so let's modify it.
        $in{'modify'} = $hits[0];
        &html_modify_form_record();
    }
    else {
        my ($maxhits) = $db_max_hits;
        $maxhits = $in{'mh'} if ($in{'mh'});

        &html_print_headers;
        print qq|
<HTML>
<HEAD>
    <TITLE>ק</TITLE>
</HEAD>

<$body>
    <H2><TT>ק.</TT></H2>
    <P>ˬdUCƨǬOAƱק, Ы "ק":
|;
# Print out how many hits, if maximum, produce a link to get next n hits.
    if ($numhits == $maxhits) {
        print qq|<P>Ajwkӳ̤j <strong>$maxhits</strong> .
				 <A HREF="$db_search_next_url">Next $maxhits</a>?
				|;
    }
    else {
        print qq|<P>Ajwk <strong>$numhits</strong> :
				 <P>|;
    }
    
print qq|<P>
    <FORM ACTION="$db_script_url" METHOD="POST">
    <TABLE>|;

# Go through each hit and convert the array to hash and send to 
# html_record for printing. Also add a radio button with name=modify
# and value=key.
    if ($status ne "ok") {  # Error searching database!
        print qq|<TR><TD><FONT COLOR="RED" SIZE=4> ~: $status</FONT></TD></TR>|;
    }
    else {
        for ($i = 0; $i < $numhits; $i++) {
            %tmp = &array_to_hash ($i, @hits);
            print qq|<TR><TD><INPUT TYPE=RADIO NAME="modify" VALUE="$tmp{$db_key}"></TD><TD>|;
            &html_record (%tmp);
            print qq|</TD></TR>|;
        }
    }
print qq|
    </TABLE>
    <P><INPUT TYPE="HIDDEN" NAME="modify_form_record" VALUE="1">
       <INPUT TYPE="SUBMIT" VALUE="ק"> <INPUT TYPE="RESET" VALUE="M ">
    </FORM>
    $html_footer
</BODY>
</HTML>
|;
    }
}

sub html_modify_form_mult {
# --------------------------------------------------------
# Allows modification of more then one record at a time.
#
	my ($errstr, $succstr) = @_;
	
    my ($status, @hits) = &query(); 
    my ($numhits) = ($#hits+1) / ($#db_cols+1);
	my ($maxhits) = $db_max_hits;
	$maxhits = $in{'mh'} if ($in{'mh'});

	if ($numhits == 1) {
		$in{'modify'} = $hits[0];
		&html_modify_form_record();
		return;
	}
	
	&html_print_headers;
        print qq|
<HTML>
<HEAD>
    <TITLE>ק@Ӹ</TITLE>
</HEAD>

<$body>
    <H2><TT>ק@Ӹ</TT></H2>
|;
if ($errstr) {
	print qq|<font color=red><strong>$errstr</strong></font>|;
}
if ($succstr) {
	print qq|UCUƤwק粒: <font color=red><strong>$succstr</strong></font>.|;
}
else {
	print qq|	<P>
		<p>ˬdUCƨǬOAƱק, Ы "ק":|;

# Print out how many hits, if maximum, produce a link to get next n hits.
	    if ($numhits == $maxhits) {
	        print qq|<P>Ajwkӳ̤j <strong>$maxhits</strong> .
					 <A HREF="$db_search_next_url">Next $maxhits</a>?
					|;
	    }   
print qq|
	    <FORM ACTION="$db_script_url" METHOD="POST">
	    <TABLE BORDER=1>|;
	
# We need to pre load the available categories so we don't search the database for
# every link! We store the results in $db_select_field so the script can use 
# &build_select_field as if it was a normal select field.	
	    if ($status ne "ok") {  # Error searching database!
	        print qq|<TR><TD><FONT COLOR="RED" SIZE=4> ~: $status</FONT></TD></TR>|;
	    }
	    else {
# Pre Load the category list.		
			$db_select_fields{'Category'} = $db_select_fields{'Related'} = join (",", &category_list);

# Print Column Headers
			print "<tr><th>$db_key</th>";
			foreach $col (@db_form_header_columns) {
				print qq|<th>$col</th>|;
			}
			print "</tr>";

# Print Main Body.		
	        for ($i = 0; $i < $numhits; $i++) {
	            %tmp = &array_to_hash ($i, @hits);
	            print qq|<TR><TD VALIGN=TOP><nobr><INPUT TYPE=CHECKBOX NAME="$tmp{$db_key}" VALUE="modify">$tmp{$db_key} </nobr></TD>|;
	            &html_record_form_spreadsheet (%tmp);
	            print qq|</TR>|;
	        }
			print "</table>";
	    }

# Print out how many hits, if maximum, produce a link to get next n hits.
	    if ($numhits == $maxhits) {
	        print qq|<P>Ajwkӳ̤j <strong>$maxhits</strong> records.
				 <A HREF="$db_search_next_url">U@ $maxhits</a>?
					|;
	    }   	
print qq|
	    <P><INPUT TYPE="HIDDEN" NAME="modify_record_mult" VALUE="1">
	       <INPUT TYPE="SUBMIT" VALUE="Twק"> <INPUT TYPE="RESET" VALUE="M ">
	    </FORM>
    	|; 
	}
	print qq|$html_footer
</BODY>
</HTML>
|;
}

sub html_modify_form_record {
# --------------------------------------------------------
# The user has picked a record to modify and it should appear
# filled in here stored in %rec. If we can't find the record,
# the user is sent to modify_failure.

    my (%rec) = &get_record($in{'modify'});
    if (!%rec) { &html_modify_failure("O/Ow: $in{'modify'}"); }
    else {
        &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>ק@Ӹ</TITLE>
</HEAD>

<$body>
    <H2><TT>ק@Ӹ</TT></H2>
        <FORM ACTION="$db_script_url" METHOD="POST">
            |; &html_record_form (%rec); print qq|
           <P><INPUT TYPE="HIDDEN" NAME="modify_record" VALUE="1">
           <INPUT TYPE="SUBMIT" VALUE="Twק"> <INPUT TYPE="RESET" VALUE="M ">
         </FORM>
    $html_footer
</BODY>
</HTML>
|;
    }
}

sub html_modify_success {
# --------------------------------------------------------
# The user has successfully modified a record, and this page will 
# display the modified record as a confirmation.

    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>ƭק</TITLE>
</HEAD>

<$body>
    <H2><TT>ƭק</TT></H2>
    <P><Font face="sө,з" Size=2>UCUƤwק粒:</FONT>
    |; &html_record(&get_record($in{$db_key})); print qq|
    $html_footer
</BODY>
</HTML>
|;
}

sub html_modify_failure {
# --------------------------------------------------------
# There was an error modifying the record. $message contains
# the reason why.

    my ($message) = $_[0];
    
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE> ~! Lkק.</TITLE>
</HEAD>

<$body>
    <H2><TT><FONT COLOR="red"> ~! Lkק.</FONT></TT></H2>
    <P>HUOܦUקƦ: <FONT COLOR="red"><B>$message</B></FONT>
    <BR>Эץ󪺰Dιխsק.
    <P>
    <FORM ACTION="$db_script_url" METHOD="POST">
        |; &html_record_form (%in); print qq|
       <P><INPUT TYPE="HIDDEN" NAME="modify_record" VALUE="1">
       <INPUT TYPE="SUBMIT" VALUE="ק"> <INPUT TYPE="RESET" VALUE="M ">
     </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

##########################################################
##					  Validation						##
##########################################################
sub html_validate_form {
# --------------------------------------------------------
# This page produces a list of records waiting to be validated, 
# from which the admin can either delete, or validate the records.

# First let's just get a list of all the records to validate/modify.
    my (@lines, @valhits, @modhits, $numhits, $counter);

    open (VALIDATE, "<$db_valid_name") or &cgierr("Lk}: $db_valid_name. z: $!");    
        @lines = <VALIDATE>;
    close VALIDATE; 
    LINE: foreach $line (@lines) {
        next LINE if ($line =~ /^#/); next LINE if ($line =~ /^\s*$/);
        push (@valhits, &split_decode($line));
    }
    open (MODIFY, "<$db_modified_name") or &cgierr("Lk}: $db_valid_name. z: $!");    
        @lines = <MODIFY>;
    close MODIFY; 
    LINE: foreach $line (@lines) {
        next LINE if ($line =~ /^#/); next LINE if ($line =~ /^\s*$/);
        push (@modhits, &split_decode($line));
    }	
    $numhits = (($#valhits+1) + ($#modhits+1)) / ($#db_cols+1);

# Now let's print out the page:     
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>ҵn</TITLE>
</HEAD>

<$body>
    <font COLOR=BLUE><H2><TT>ҵn</TT></H2></FONT><font size=2>
    <P>ثe<font COLOR=RED> ($numhits) </FONT>ƵԧA, Ы "n/R". @u 10 . <br>
       pˬds:  Ы "d" }@ӷsw.<br>
       pݶlq: Цblq "YES". <br>
       pܸԲӸ: Цbܸ "YES".</font>
    <FORM ACTION="$db_script_url" METHOD="POST">
         <TABLE BORDER=1>|;
# Print Column Headers
		print "<tr><th>dҩΧR</th>";
		foreach $col (@db_form_header_columns) {
			print qq|<th>$col</th>|;
		}
		print "</tr>";
		
# Pre Load Category List
$db_select_fields{'Category'} = join (",", &category_list);

# Counter, we only want to display 10 at a time.
	$counter = 0;

# Go through each validated hit and convert the array to hash and send to 
# html_record for printing. Also add a checkbox with name=key and value=delete.
    for ($i = 0; $i < ($#valhits+1) / ($#db_cols+1); $i++) {
		last if (++$counter > 10);
        %tmp = &array_to_hash ($i, @valhits);
        print qq|<TR><TD>
<a href="$tmp{'URL'}" target="_blank">
 d </a>: <INPUT TYPE="RADIO" NAME="$tmp{$db_key}" VALUE="validate"><br>
 R : <INPUT TYPE="RADIO" NAME="$tmp{$db_key}" VALUE="delete"></TD>|;
        &html_record_form_spreadsheet (%tmp);
        print qq|</TD></TR>|;
    }

# Go through each modified hit and convert the array to hash and send to 
# html_record for printing. Also add a checkbox with name=key and value=delete.
    for ($i = 0; $i < ($#modhits+1) / ($#db_cols+1); $i++) {
		last if (++$counter > 10);
        %tmp = &array_to_hash ($i, @modhits);
        print qq|<TR><TD>
 : <INPUT TYPE="RADIO" NAME="$tmp{$db_key}" VALUE="modify"><br>
R : <INPUT TYPE="RADIO" NAME="$tmp{$db_key}" VALUE="delete"></TD>|;
        &html_record_form_spreadsheet (%tmp);
        print qq|</TD></TR>|;
    }


print qq|
    </TABLE>
    <P><INPUT TYPE="HIDDEN" NAME="validate_records" VALUE="1">
       <INPUT TYPE="SUBMIT" VALUE="n/R"> <INPUT TYPE="RESET" VALUE="M ">
    </FORM>
    $html_footer
</BODY>
</HTML>
|;
}

sub html_validate_success {
# --------------------------------------------------------
# This page let's the user know that the records were successfully
# validated.
	my ($valsuc, $modsuc, $delsuc) = @_;
	
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE> n/R</TITLE>
</HEAD>

<$body>
    <H2><TT> n/R</TT></H2>
    <P>|; 
	
print "UCUƤwn: $valsuc<br>" if ($valsuc);
print "UCUƤwק: $modsuc<br>" if ($modsuc);
print "UCUƤwR: $delsuc<br>" if ($delsuc);
print qq|
$html_footer
</BODY>
</HTML>
|;
}

sub html_validate_failure {
# --------------------------------------------------------
# This page let's the user know that some/all of the records were
# not validated (because they were not found in the database). 
# $errstr contains a list of records not deleted.

    my ($errstr) = $_[0];
    
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE> ~: nưD</TITLE>
</HEAD>

<$body>
    <H2><TT><FONT COLOR="red"> ~: nưD</FONT></TT></H2>
    <P>HUOܦUnƦ:
	<FONT COLOR="red">	
	<ul>
	$errstr
	</ul>
	</FONT>.
    <P>|; 
	
print "UCUƤwn: $valsuc<br>" if ($valsuc);
print "UCUƤwק: $modsuc<br>" if ($modsuc);
print "UCUƤwR: $delsuc<br>" if ($delsuc);
print qq|	
$html_footer
</BODY>
</HTML>
|;  
}

##########################################################
##				Email Messages          ##
##########################################################

sub html_validate_email {
# --------------------------------------------------------
# All the link information is stored in %link.
	my (%link) = @_;

	open (MAIL, "|$db_mail_path") or &cgierr ("~Lk}_l{: $db_mail_path. z: $!");
	print MAIL "To: $link{'Contact Name'} <$link{'Contact Email'}>\n";
	print MAIL "From: $db_admin_email\n";
	print MAIL "Subject: QqƤw[JƮw!\n\n";
	print MAIL qq|
§AӳXڭ̪. ڭ̦znUCUQqƦb
ڭ̪:

        W: $link{'Title'}
            }: $link{'URL'}
        u: $link{'Category'}
        ²: $link{'Description'}
        ޲zH: $link{'Contact Name'}
        qll: $link{'Contact Email'}

AݨnƦb:

  $build_root_url

pA󪺰D, мgHӵo. nS!

uۦa, §An!

|;
	close MAIL;
}

sub html_modify_email {
# --------------------------------------------------------
# All the link information is stored in %link.
	my (%link) = @_;

	open (MAIL, "|$db_mail_path") or &cgierr ("~Lk}_l{: $db_mail_path. z: $!");
	print MAIL "To: $link{'Contact Name'} <$link{'Contact Email'}>\n";
	print MAIL "From: $db_admin_email\n";
	print MAIL "Subject: ץQq!\n\n";
	print MAIL qq|
§AӳXڭ̪. ڭ̦AnDק諸UCUQqƦb
ڭ̪:

        W: $link{'Title'}
            }: $link{'URL'}
        u: $link{'Category'}
        ²: $link{'Description'}
        ԲӸ: $link{'Review'}
        ޲zH: $link{'Contact Name'}
        qll: $link{'Contact Email'}

Aݨק諸Ʀb:

  $build_root_url
  

pA󪺰D, мgHӵo. nS!

uۦa,

§A!

|;
	close MAIL;
}

##########################################################
##					  Misc								##
##########################################################

sub html_check_links {
# --------------------------------------------------------
# This routine checks to make sure that there are no links w/o
# associated categories.
#

	my ($bad_category, @bad_links) = @_;
    my ($numhits) = ($#bad_links+1) / ($#db_cols+1);
    
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>ˬds</TITLE>
</HEAD>

<$body>
    <H2><TT>ˬds: sŦX.</TT></H2>
|;
    if (!$bad_category) {
        print qq|<P>SD!|;
    }
    else {
        print qq|<P>bAƮw@ǳs, OM@ӥؿp, 
                    ӧAؿƮwSoؿW. A <b>N</b> RDs,Ϊ̼W[򥢪ؿ.
		 <P>W[ؿ, AQW[lؿ. 
                    Rs, AQRs (<strong>O: ͤ@ max  $db_max_hits sR</strong>).
			     <FORM ACTION="$db_script_url/category" METHOD="POST">
				 <SCRIPT LANGUAGE="Javascript">
				 <!--
				 	function check_all () {
						var loop = 0;
						for (loop=0; loop < window.document.forms[0].elements.length; loop++) {							
							window.document.forms[0].elements[loop].checked = true;
						}
					}
					
					function clear_all () {
						var loop = 0;
						for (loop=0; loop < window.document.forms[0].elements.length; loop++) {							
							window.document.forms[0].elements[loop].checked = false;
						}
					}						
				// -->
				 </SCRIPT>
				 <P><INPUT TYPE=BUTTON VALUE="Check All" OnClick="check_all(); return true;">
				    <INPUT TYPE=BUTTON VALUE="Clear All" OnClick="clear_all(); return true;"></P>
				 <P>
				 <TABLE BORDER=1>$bad_category</TABLE>
				 <P><INPUT TYPE="HIDDEN" NAME="add_record_mult" VALUE="1">
				 <INPUT TYPE="SUBMIT" VALUE="[lؿ"> <INPUT TYPE="RESET" VALUE="M "></FORM>
				 <hr width=100% size=1 noshade>
				 <p>Rr֪s,lMR:
    			 <FORM ACTION="$db_script_url/links" METHOD="POST">
		         <TABLE BORDER=1>
		|;
		# Print Column Headers
				print "<tr><th>R </th>";
				foreach $col (@db_record_header_columns) {
					print qq|<th>$col</th>|;
				}
		print "</tr>";
		for ($i = 0; $i < $numhits; $i++) {
			%tmp = &array_to_hash ($i, @bad_links);
			print qq|<TR><TD><INPUT TYPE=CHECKBOX NAME="$tmp{$db_key}" VALUE="delete"></TD>|;
			&html_record_spreadsheet (%tmp);
			print qq|</TR>|;
		}
		print qq|
			    </TABLE>
			    <P><INPUT TYPE="HIDDEN" NAME="delete_records" VALUE="1">
			       <INPUT TYPE="SUBMIT" VALUE="Rl"> <INPUT TYPE="RESET" VALUE="M ">
			    </FORM>
	    |; 
	}
	print qq|
	$html_footer
</BODY>
</HTML>
|;
}

sub html_check_duplicates {
# --------------------------------------------------------
# This routine checks to see if there are any duplicate links.
#

	my (@dup_links) = @_;
    my ($numhits) = ($#dup_links+1) / ($#db_cols+1);
    
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>ˬdƻss.</TITLE>
</HEAD>

<$body>
    <H2><TT>ˬds: ƻss.</TT></H2>
|;
	if (!$numhits) {
		print "<P>Lkƻs!";
	}
	else {
		print qq|
			 <p>Rr֪s, lMR:
	 		<FORM ACTION="$db_script_url/links" METHOD="POST">
		     <TABLE BORDER=1>
		|;
# Print Column Headers
		print "<tr><th>R </th>";
		foreach $col (@db_record_header_columns) {
			print qq|<th>$col</th>|;
		}
		print "</tr>";
	
		for ($i = 0; $i < $numhits; $i++) {
			%tmp = &array_to_hash ($i, @dup_links);
			print qq|<TR><TD><INPUT TYPE=CHECKBOX NAME="$tmp{$db_key}" VALUE="delete"></TD>|;
			&html_record_spreadsheet (%tmp);
			print qq|</TR>|;
		}
		print qq|
		    </TABLE>
			    <P><INPUT TYPE="HIDDEN" NAME="delete_records" VALUE="1">
			       <INPUT TYPE="SUBMIT" VALUE="Rl"> <INPUT TYPE="RESET" VALUE="M ">
			    </FORM>
	    |; 
	}
	print qq|
	$html_footer
</BODY>
</HTML>
|;
}

sub html_unkown_action {
# --------------------------------------------------------
# The program received a command it did not recognize.

    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE> ~! ʧ@LkT{.</TITLE>
</HEAD>

<$body>
    <H2><TT> ~! ʧ@LkT{</TT></H2>
    <P>Ʈw{Ǥ@өROHPLkT{. Oo,AIs
       {]t html ɮ, Wa.  
     $html_footer       
</BODY>
</HTML>
|;
}

1;